#include "N76E003.h"
#include "Common.h"
#include "Delay.h"
#include "SFR_Macro.h"
#include "Function_define.h"
#include <stdio.h>



#define 		IR_Leader_MARK    			16//16*560us
#define 		IR_Leader_SPACE   			8//8*560us
#define 		IR_BIT_MARK           	1//1*560us
#define     IR_ONE_SPACE           	3//3*560us      
#define     IR_ZERO_SPACE         	1//1*560us      
#define     IR_BYTES              	4

sbit KEY3 = P1^3;
sbit KEY4 = P1^4;
void IR_Send_MARK(uint8_t N)
{
	PWM0_P12_OUTPUT_ENABLE;
	Timer0_Delay560us(N);
	PWM0_P12_OUTPUT_DISABLE;
	
}
void IR_Send_SPACE(uint8_t N)
{
	Timer0_Delay560us(N);

}
void IR_Send(uint8_t* irdata)
{
    uint8_t nbyte;
    uint8_t nbit;
	
    /* Send out Leader code */
    IR_Send_MARK(IR_Leader_MARK);
    IR_Send_SPACE(IR_Leader_SPACE);

    /* Send out Customer code and Data code */
    for(nbyte = 0; nbyte < IR_BYTES; nbyte++)
    {
        for(nbit = 0; nbit < 8; nbit++)
        {
            IR_Send_MARK(IR_BIT_MARK);
            if(irdata[nbyte] & (1 << nbit))       // LSB first
                IR_Send_SPACE(IR_ONE_SPACE);
            else
                IR_Send_SPACE(IR_ZERO_SPACE);
        }
    }

    /* Send out Stop bit */
    IR_Send_MARK(IR_BIT_MARK);
}
unsigned char Get_Key_Input(void)
{
    unsigned char temp = 0;
	
    if(KEY3 == 0)
		{
				 temp |= 0x4;
		}
    if(KEY4 == 0)
		{
				 temp |= 0x8;
		}
    return   temp;
}
void main(void)
{
	uint8_t IR_CODE[4];
	Set_All_GPIO_Quasi_Mode;
	P12_PushPull_Mode;
	P12 = 0;
	P13_Input_Mode;
	P14_Input_Mode;

	PWM_IMDEPENDENT_MODE;
	PWM_CLOCK_DIV_2;
		set_CLRPWM;
		PWMPH = 0x00;
		PWMPL = 0xD2;  //38Khz 26.5us
/**********************************************************************
	PWM frequency = Fpwm/((PWMPH,PWMPL) + 1) <Fpwm = Fsys/PWM_CLOCK_DIV> 
								= (16MHz/2)/(0xD2 + 1)
								= 38KHz 
***********************************************************************/	

		PWM0H = 0x00;							//PWM0 high duty = 1/3 PWM period
		PWM0L = 0x46;	

//		set_EPWM;									//Enable PWM interrupt
//		set_EA;
    set_LOAD;
    set_PWMRUN;
//		clr_PWMRUN;
		IR_CODE[0] = 0x83;
		IR_CODE[1] = 0x55;

	while(1)
	{
		if(Get_Key_Input() & 0x04)
		{
				IR_CODE[2] = 0x90;
				IR_CODE[3] = ~IR_CODE[2];
				IR_Send(IR_CODE);
				Timer0_Delay1ms(100);
		}
    if(Get_Key_Input() & 0x08)
		{
				IR_CODE[2] = 0x3F;
				IR_CODE[3] = ~IR_CODE[2];
				IR_Send(IR_CODE);
				Timer0_Delay1ms(100);
		}
	}
}
